﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;
using System.Collections.ObjectModel;

namespace DataTreeLazyLoading
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            dataTree.NodeExpansionChanged += new EventHandler<NodeExpansionChangedEventArgs>(dataTree_NodeExpansionChanged);

            var dataSource = new ObservableCollection<Person>() { new Person("John"), new Person("Peter"), new Person("Amber"), new Person("Mery") };
            dataTree.ItemsSource = dataSource;
        }

        void dataTree_NodeExpansionChanged(object sender, NodeExpansionChangedEventArgs e)
        {
            XamDataTreeNode node = e.Node;
            if (node.IsExpanded)
            {
                var person = (node.Data as Person);

                if (node.NodeLayout.Key == "Cars")
                {
                    person.LoadCars();
                }
                if (node.NodeLayout.Key == "Pets")
                {
                    person.LoadPets();
                }

            }
        }
    }
}
