﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Collections.ObjectModel;

namespace DataTreeLazyLoading
{
    public class Person
    {
        int _petsCount = 0;

        #region ctor
        public Person()
        {
            this.Name = string.Empty;

        }

        public Person(string name)
        {
            ArePetsLoaded = false;
            AreCarsLoaded= false;
            this.Name = name;

            Random r = new Random();
            _petsCount = r.Next(0, 5);

            this.Cars = new ObservableCollection<Car>() { default(Car) }; //We need to have at least one element so the expansion indicator will be displayed
            this.Pets = new ObservableCollection<Pet>() { default(Pet)}; //We need to have at least one element so the expansion indicator will be displayed
        } 
        #endregion //ctor

        #region Properties
        public string Name { get; set; }

        public ObservableCollection<Car> Cars { get; set; }
        public bool AreCarsLoaded { get; set; }

        public ObservableCollection<Pet> Pets { get; set; }
        public bool ArePetsLoaded{ get; set; } 
        #endregion //Properties

        #region Methods

        public void LoadCars()
        {
            if (AreCarsLoaded)
                return;

            this.Cars.Clear();
            this.Cars.Add(new Car() { Model = string.Format("{0}'s car 1", this.Name) });
            this.Cars.Add(new Car() { Model = string.Format("{0}'s car 2", this.Name) });

            AreCarsLoaded = true;

            Debug.WriteLine(string.Format("{0}'s cars loaded", this.Name));
        }

        public void LoadPets()
        {
            if (ArePetsLoaded)
                return;

            this.Pets.Clear();

            for (int i = 1; i <= _petsCount; i++)
                this.Pets.Add(new Pet() { PetName = string.Format("{0}'s pet {1}", this.Name, i) });

            ArePetsLoaded = true;

            Debug.WriteLine(string.Format("{0}'s pets loaded", this.Name));
        } 

        #endregion //Methods
    }

    public class Car
    {
        public string Model { get; set; }
    }
    public class Pet
    {
        public string PetName { get; set; }
    }
}
